// Rust will try to clean up the program after a panic! is reached
// If want a smaller binary size, set:
// ```cargo.toml
// [profile.release]
// panic = 'abort'
// ```
// to let the operating system handle the clean up.
// When Rust handles this, named unwinding
//
// Use RUST_BACKTRACE=1 %command% to see the full backtrace
//   in case the panic isn't from your code directly.

fn main() {
    panic!("crash and burn");
}
